@ECHO OFF
REM
REM    FIXPERMS 1.02
REM    Copyright (C) 201 Josh Rodd
REM
REM    This program is free software: you can redistribute it and/or modify
REM    it under the terms of the GNU General Public License as published by
REM    the Free Software Foundation, either version 3 of the License, or
REM    (at your option) any later version.
REM
REM    This program is distributed in the hope that it will be useful,
REM    but WITHOUT ANY WARRANTY; without even the implied warranty of
REM    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
REM    GNU General Public License for more details.
REM
REM    You should have received a copy of the GNU General Public License
REM    along with this program.  If not, see <http://www.gnu.org/licenses/>
REM
IF "%1"=="" GOTO USAGE
IF "%1"=="/?" GOTO USAGE
IF "%1"=="--help" GOTO USAGE
IF "%1"=="--version" GOTO VERSION
SET TARGET=%1
SHIFT
SET NEWUSER=%1
IF "%NEWUSER%"=="" SET NEWUSER=%USERDOMAIN%\%USERNAME%
echo TAKEOWN /R /D /Y /F %TARGET% & echo ICACLS %TARGET% /GRANT:R BUILTIN\Administrators:(F) /GRANT BUILTIN\Administrators:(OI)(CI)(IO)(F) /GRANT:R "NT AUTHORITY\SYSTEM":(F) /GRANT "NT AUTHORITY\SYSTEM":(OI)(CI)(IO)(F) /GRANT:R "NT AUTHORITY\Authenticated Users":(M) /GRANT "NT AUTHORITY\Authenticated Users":(OI)(CI)(IO)(M) /GRANT:R BUILTIN\Users:(RX) /GRANT BUILTIN\Users:(OI)(CI)(IO)(GR,GE) /GRANT:R "%NEWUSER%":(F) /GRANT "%NEWUSER%":(OI)(CI)(IO)(F) & echo ATTRIB -S -H -R -A %TARGET% /S /D /L
GOTO END
:USAGE
ECHO Resets ownership and permissions to normal Windows 7 defaults for a domain-
ECHO joined machine.
ECHO.
ECHO %0 [/?|--help|--version] target [domain\user]
ECHO.
ECHO   target       The file or folder to be affected. All subdirectories will be
ECHO                affected as well.
ECHO   domain\user  The new owner of the files, in addition to the default
ECHO                permissions. If not specified, the current domain and user
ECHO                will be used (%USERDOMAIN%\%USERNAME%).
ECHO   /?           Display this usage summary.
ECHO   --help       Same as /?
ECHO   --version    Display version, license, and warranty information.
ECHO.
GOTO END
:VERSION
ECHO FIXPERMS 1.02
ECHO Copyright (C) 2017 Josh Rodd
ECHO License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>
ECHO This is free software: you are free to change and redistribute it.
ECHO There is NO WARRANTY, to the extent permitted by law. Please see the file
ECHO called COPYING.TXT for more information.
ECHO.
ECHO Please look for updates at https://josh.rodd.us/software/fixperms
:END
